//https://stackoverflow.com/questions/23098415/visitor-listener-code-for-a-while-loop-in-antlr-4

grammar Arit;

@header {
#header - mettre les variables globales 
idTab = {};
}

@members {
# members - relire la doc 
}

prog:   expr EOF #toplevel
    ;
	
expr:
	expr mdop expr     #multiplicationExpr
    | expr pmop expr     #additiveExpr
    | atom                            #atomExpr
    ;

atom 
    :   INT                 #int
    |   ID                  #id
    |   '(' expr ')'        #parens
    ;

mdop: MULT | DIV;
pmop: PLUS | MINUS;

PLUS : '+';
MINUS : '-';
MULT : '*';
DIV : '/';
ID  :   ('a'..'z'|'A'..'Z')+ ;
INT :   '0'..'9'+ ;
WS  :   (' '|'\t'|'\n'|'\r')+  -> skip;



