//https://stackoverflow.com/questions/23098415/visitor-listener-code-for-a-while-loop-in-antlr-4

grammar Arit;

@header {
#header - mettre les variables globales 
idTab = {};
}

@members {
# members - relire la doc 
}

prog:   stat+  #statList
    ;
                
stat:   expr NEWLINE        #printExpr
    |   ID '=' expr NEWLINE #assign
    |   NEWLINE             #blank
    ;

expr:
      expr mdop=(MULT | DIV) expr     #multiplicationExpr
    | expr pmop=(PLUS | MINUS) expr     #additiveExpr
    | atom                            #atomExpr
    ;

atom 
    :   INT                 #int
    |   ID                  #id
    |   '(' expr ')'        #parens
    ;

PLUS : '+';
MINUS : '-';
MULT : '*';
DIV : '/';
ID  :   ('a'..'z'|'A'..'Z')+ ;
INT :   '0'..'9'+ ;
NEWLINE:'\r'? '\n' ;
WS  :   (' '|'\t')+  -> skip;

