from AritLexer import AritLexer
from AritParser import AritParser
from AritVisitor import AritVisitor
from MyAritVisitor import MyAritVisitor

from antlr4 import CommonTokenStream, InputStream
import sys

def main():
    lexer = AritLexer(InputStream(sys.stdin.read()))
    stream = CommonTokenStream(lexer)
    parser = AritParser(stream)
    tree = parser.prog()
    print("I'm here : nothing has been done")
    
    visitor = MyAritVisitor()
    visitor.visit(tree)

if __name__ == '__main__':
    main()

